
function fileQueued(file) {
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setStatus("Pending...");
		progress.toggleCancel(true, this);

	} catch (ex) {
		this.debug(ex);
	}

}

function fileQueueError(file, errorCode, message) {
	try {
		if (errorCode === SWFUpload.QUEUE_ERROR.QUEUE_LIMIT_EXCEEDED) {
			alert("上传文件超过限制.\n" + (message === 0 ? "You have reached the upload limit." : "上传 " + (message > 1 ? "列队不可超过" + message + "个文件." : "总数超过限制.")));
			return;
		}

		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setError();
		progress.toggleCancel(false);

		switch (errorCode) {
		case SWFUpload.QUEUE_ERROR.FILE_EXCEEDS_SIZE_LIMIT:
			progress.setStatus("File is too big.");
			this.debug("Error Code: File too big, File name: " + file.name + ", File size: " + file.size + ", Message: " + message);
			break;
		case SWFUpload.QUEUE_ERROR.ZERO_BYTE_FILE:
			progress.setStatus("Cannot upload Zero Byte files.");
			this.debug("Error Code: Zero byte file, File name: " + file.name + ", File size: " + file.size + ", Message: " + message);
			break;
		case SWFUpload.QUEUE_ERROR.INVALID_FILETYPE:
			progress.setStatus("Invalid File Type.");
			this.debug("Error Code: Invalid File Type, File name: " + file.name + ", File size: " + file.size + ", Message: " + message);
			break;
		default:
			if (file !== null) {
				progress.setStatus("Unhandled Error");
			}
			this.debug("Error Code: " + errorCode + ", File name: " + file.name + ", File size: " + file.size + ", Message: " + message);
			break;
		}
	} catch (ex) {
        this.debug(ex);
    }
}

//视频
function fileDialogComplete(numFilesSelected, numFilesQueued) {
	try {
		if (numFilesSelected > 0) {
			document.getElementById(this.customSettings.cancelButtonId).disabled = false;
		}
		this.button_disabled = true;
		//this.callFlash("SetButtonDisabled", [true]);
		/* I want auto start the upload and I can do that here */
		this.startUpload();
	} catch (ex)  {
        this.debug(ex);
	}
}

//动态改变上传视频post值
function uploadStart(file) {
	try {
		
		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setStatus("Uploading...");
		progress.toggleCancel(true, this);
		
		document.getElementById("video_message").style.display = "block";
		var sourceList = document.getElementById('sourceList').value;

		var source_num = document.getElementById('source_num').value;
		
		var postobj = { "sourceList": sourceList , "source_num":source_num};
		this.callFlash("SetPostParams", [postobj]);
		
	}
	catch (ex) {}
	
	return true;
}

function uploadProgress(file, bytesLoaded, bytesTotal) {
	//this.callFlash("SetButtonDisabled", [true]);
	try {
		var percent = Math.ceil((bytesLoaded / bytesTotal) * 100);

		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setProgress(percent);
		progress.setStatus("Uploading...");
		document.getElementById('isupload').value="uploading";
	} catch (ex) {
		this.debug(ex);
	}
}

//视频
function uploadSuccess(file, serverData) {
	
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget);
		//隐藏成功项
		progress.setComplete();
		//控制关闭按钮
		progress.toggleCancel(false,this);
		progress.setStatus("上传成功");
		
		if(""!=serverData){
			
			//var video_list=serverData.split("#");
			
			document.getElementById('avatar_box').innerHTML=serverData;
	      
			
			this.callFlash("SetButtonDisabled", [false]);
		}else{
			alert("请选择图片文件");
		}
	} catch (ex) {
		this.debug(ex);
	}
}

function uploadError(file, errorCode, message) {
	try {
		var progress = new FileProgress(file, this.customSettings.progressTarget);
		progress.setError();
		progress.toggleCancel(false);

		switch (errorCode) {
		case SWFUpload.UPLOAD_ERROR.HTTP_ERROR:
			progress.setStatus("Upload Error: " + message);
			this.debug("Error Code: HTTP Error, File name: " + file.name + ", Message: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_FAILED:
			progress.setStatus("Upload Failed.");
			this.debug("Error Code: Upload Failed, File name: " + file.name + ", File size: " + file.size + ", Message: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.IO_ERROR:
			progress.setStatus("Server (IO) Error");
			this.debug("Error Code: IO Error, File name: " + file.name + ", Message: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.SECURITY_ERROR:
			progress.setStatus("Security Error");
			this.debug("Error Code: Security Error, File name: " + file.name + ", Message: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_LIMIT_EXCEEDED:
			progress.setStatus("Upload limit exceeded.");
			this.debug("Error Code: Upload Limit Exceeded, File name: " + file.name + ", File size: " + file.size + ", Message: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.FILE_VALIDATION_FAILED:
			progress.setStatus("Failed Validation.  Upload skipped.");
			this.debug("Error Code: File Validation Failed, File name: " + file.name + ", File size: " + file.size + ", Message: " + message);
			break;
		case SWFUpload.UPLOAD_ERROR.FILE_CANCELLED:
			// If there aren't any files left (they were all cancelled) disable the cancel button
			if (this.getStats().files_queued === 0) {
				document.getElementById(this.customSettings.cancelButtonId).disabled = true;
			}
			progress.setStatus("Cancelled");
			progress.setCancelled();
			break;
		case SWFUpload.UPLOAD_ERROR.UPLOAD_STOPPED:
			progress.setStatus("Stopped");
			break;
		default:
			progress.setStatus("Unhandled Error: " + errorCode);
			this.debug("Error Code: " + errorCode + ", File name: " + file.name + ", File size: " + file.size + ", Message: " + message);
			break;
		}
	} catch (ex) {
        this.debug(ex);
    }
}

//视频
function uploadComplete(file) {
	if (this.getStats().files_queued === 0) {
		document.getElementById(this.customSettings.cancelButtonId).disabled = true;
		//document.getElementById("bu").style.display="none";
	}
}


// This event comes from the Queue Plugin
function queueComplete(numFilesUploaded) {
	var status = document.getElementById("divStatus");
	
	status.innerHTML = numFilesUploaded + " file" + (numFilesUploaded === 1 ? "" : "s") + " uploaded.";
}


/*
* 判断上传完成后才可创建素材
* 
*/
function isUploadComplete(){
	

	var videoName = document.getElementById('columnName').value;
	
	if(""==videoName) {alert("请填写标题");return false;}
	
	//获得类型
	var cidlist = document.getElementsByName('columnType');
	var cid="0";
    if(cidlist!=null){
        var i;
        for(i=0;i<cidlist.length;i++){
            if(cidlist[i].checked){
            	cid= cidlist[i].value;            
            }
        }
    }
	
    if("0"==cid){ alert("请选择类型");return false;}

	//视频是否上传完成
	var isuploadsuccess = document.getElementById('isupload').value;
	if("uploading"==isuploadsuccess){ alert("文件未上传完成,请稍等...");return false;}
	
	//是否共享
	var publicSign_list = document.getElementById('publicSign').value;
	var publicSign="2";
	
	document.getElementById("form1").submit();
}

function createPicCtrl(pic_url,wnd_width,wnd_height){
	var wnd_ctrl = $("<div></div>").width(wnd_width).height(wnd_height).css({position:"relative",overflow:"hidden"});
	var img = new Image();//$("<img></img>").attr("src",pic_url);
	img.src =  pic_url;
	wnd_ctrl.append(img);

	return wnd_ctrl;
	
	
}
