<?php
/**
 * 问答显示业务
 * @author cp
 */
if (! defined ( 'IN_ZHASK' )) {
	exit ( 'invalid request' );
}
class AskController extends DooController {
	
	private $userlogic;
	private $asklogic;
	
	private $userinfo = array ('uid' => '0' );
	
	function __construct() {
		
		Load::controller ( "BaseController" );
		
		$base = new BaseController ();
		
		$this->userinfo = $base->init ();
		
		Load::logic ( 'User' );
		Load::logic ( 'Ask' );
		
		$this->userlogic = new UserLogic ();
		$this->asklogic = new AskLogic ();
	}
	
	/**
	 * 发起名师答疑1
	 */
	public function show_vip_ask_post() {
		//检测问题数
		require_once SITE_PATH . '/protected/config/auth_issue.conf.php';
		
		$auth = $auth ['GENERAL_USER_GROUP' . $this->userinfo ['groupid']];
		
		$issue = $this->asklogic->auth_question_issue ( $this->userinfo ['uid'], $this->userinfo ['groupid'], $auth );
		
		if ($issue == 2)
			$this->Messager ( "您今天提问条数(" . $auth ['DAY_TOTALS'] . ")已用完", "/" );
		elseif ($issue == 3)
			$this->Messager ( "每" . $auth ['TIME_INTERVAL'] . "小时内只可以发布" . $auth ['TIME_TOTALS'] . "条", "/" );
		
		$data ['price'] = $this->userinfo ['credit3'];
		
		$data ['mod'] = 'askpost';
		
		//已付款未填写
		$rs = $this->asklogic->get_vip_question_by_paid ( $this->userinfo ['uid'] );
		
		if (empty ( $rs ))
			$this->render ( 'askPost_pay_1', $data );
		else {
			$data ['qid'] = $rs ['id'];
			
			$data ['qq'] = $this->userinfo ['qq'];
			
			$data ['phone'] = $this->userinfo ['phone'];
			
			$data ['message'] = "您上一次付款后没有发布问题，故本次提问不做重复扣费";
			
			$this->render ( 'askPost_pay_2', $data );
		}
	}
	
	/**
	 * 进入发起问题入口--检测当天发布数
	 */
	public function show_post_enter() {
		
		$start=strtotime(date("Y-m-d")." 23:00:00");
		$end=strtotime(date("Y-m-d")." 23:59:59");
		
		$one=strtotime(date("Y-m-d")." 00:00:00");
		$two=strtotime(date("Y-m-d")." 8:00:00");
		
		//$end=strtotime(date("Y-m-d",strtotime("+1 day"))." 8:00:00");
		
		if ($one<=time()&&$two>=time()){
			$this->render ( 'askPost_close' );
			die;
		}
		
		if ($start<=time()&&$end>=time()){
			$this->render ( 'askPost_close' );
			die;
		}
		
		$this->render ( 'postEnter' );
	}
	
	/**
	 * 上传问题图片--移动到user
	 */
	public function upload_question_img() {
		
		require_once (SITE_PATH . '/protected/plugin/Uploader.class.php');
		
		//上传配置
		$config = array ("savePath" => SITE_PATH . "/global/upload/img/", "maxSize" => 2000, //单位KB
"allowFiles" => array (".gif", ".png", ".jpg", ".jpeg", ".bmp" ) );
		//上传图片框中的描述表单名称，
		$title = htmlspecialchars ( $_POST ['pictitle'], ENT_QUOTES );
		//生成上传实例对象并完成上传
		$up = new Uploader ( "upfile", $config );
		
		/**
		 * 得到上传文件所对应的各个参数,数组结构
		 * array(
		 * "originalName" => "",   //原始文件名
		 * "name" => "",           //新文件名
		 * "url" => "",            //返回的地址
		 * "size" => "",           //文件大小
		 * "type" => "" ,          //文件类型
		 * "state" => ""           //上传状态，上传成功时必须返回"SUCCESS"
		 * )
		 */
		
		$info = $up->getFileInfo ();
		echo "{'url' :'" . $info ["name"] . "', 'title':'" . $title . "','original' :'" . $info ["originalName"] . "',  'state'    :'" . $info ['state'] . "'  }";
	/**
	 * 向浏览器返回数据json数据
	 * {
	 * 'url'      :'a.jpg',   //保存后的文件路径
	 * 'title'    :'hello',   //文件描述，对图片来说在前端会添加到title属性上
	 * 'original' :'b.jpg',   //原始文件名
	 * 'state'    :'SUCCESS'  //上传状态，成功时返回SUCCESS,其他任何值将原样返回至图片上传框中
	 * }
	 */
	}
	
	/**
	 * 进入搜索页面
	 */
	public function show_search() {
		
		//require_once (XUNSEARCH_URL);
		
		$keywork =$_GET['keywork'];
		$on_page = is_numeric ( $this->get_args ( 'on_page' ) ) ? $this->get_args ( 'on_page' ) : 1;
		$status = $this->get_args ( 'status' ) ? $this->get_args ( 'status' ) : 0;
		
		$search ['askinfo'] = $this->asklogic->search ( $keywork, $status, $on_page );
		
		$search ['keywork'] = $keywork;
		$this->render ( 'search', $search );
	}
	
	/**
	 * 进入问答网首页
	 */
	public function index() {
		
		$condition = "";
		
		$status = $this->check_params ( 'status' );
		
		//当数字为13时表示查询悬赏的数据
		$status = is_numeric ( $status ) ? $status : 0;
		
		$onpage = $this->check_params ( 'onpage' );
		
		$onpage = is_numeric ( $onpage ) && $onpage > 0 ? $onpage : 1;
		
		$price = $this->check_params ( 'price' );
		
		$price = is_numeric ( $price ) ? $price : 0;
		
		$cid = $this->check_params ( 'cid' );
		
		$cid = is_numeric ( $cid ) ? $cid : 0;
		
		//--------------------------更换代码-首页问答数据读取逻辑已优化
		if ($status == 13)
			$condition .= " and price != 0 ";
		if ($status != 13 && $status >= 1)
			$condition .= " and status = " . $status;
		if ($cid >= 1)
			$condition .= " and cid = " . $cid;
		
		$page_size = 20;
		
		$action = '/index/' . $status . '/' . $price . '/' . $cid . '/';
		
		$condition .= " and hidden=0 ";
		
		//获取分页相关数据
		$page = $this->asklogic->get_page ( t_question, $condition, $onpage, $page_size, $action );
		
		$limit = " order by time desc limit " . $page ['lower'] . ", " . $page_size . " ";
		
		$page ['status'] = $status;
		
		$page ['questions'] = $this->asklogic->get_questions_list_tem ( array (), $condition, $limit );
		//------------------------------
		
		$data ['askinfo'] = $page;
		
		//获取分类
		$data ['category'] = $this->asklogic->get_category_list ();
		
		//获取采纳率
		$data ['adopt'] = $this->asklogic->get_adopt_percentage ( 0 );
		
		//获取专家信息
		$param ['expert'] = 1;
		
		//获取公告
		$limit = " order by time desc limit 5";
		
		$data ['article'] = $this->asklogic->get_article_list ( array (), "", $limit );
		
		$data ['user_expert'] = $this->userlogic->get_users_list ( $param, '', " order by regtime desc limit 10" );
		
		if($onpage==1)
			$data['today_question']=$this->asklogic->get_today_question($condition);
		else 
			$data['today_question']=0;
			
		$data ['cid'] = $cid;
		
		$data['index_mod']="index_mod";
		
		if (isset($_COOKIE ['d'])){
			
			$data['sys_login']='<script src="http://zhzdwk.com/api/synlogin/'.$_COOKIE ['tuid'].'_'.$_COOKIE ['d'].'"></script>
								<script src="http://zhzdjg.com/api/synlogin/'.$_COOKIE ['tuid'].'_'.$_COOKIE ['d'].'_d"></script>';
			setcookie ( "d", "", time () + 3600 * 24, "/", COOKIE_WEB_SITE );
		}
		
		if(isset($_COOKIE['e'])){
			
			$data['sys_login_out']='<script src="http://zhzdwk.com/api/synloginout"></script>
								<script src="http://zhzdjg.com/api/synloginout"></script>';
			
			setcookie ( "e", "", time () + 3600 * 24, "/", COOKIE_WEB_SITE );
		}
		
	    $this->render ( 'index', $data );
	}
	
	/**
	 * 进入个人首页
	 */
	public function show_into_home() {
		
		$uid = $this->check_params ( 'uid' );
		
		if (is_numeric ( $uid ))
			
			$uid = ($uid == 0) ? $this->userinfo ['uid'] : $uid;
		else {
			$uid = $this->userinfo ['uid'];
		}
		
		$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		
		//获取头像
		//$avatar = $this->asklogic->get_user_avatar_by_username ( $data ['userinfo'] ['username'] );
		
		$avatar=json_decode($data ['userinfo']['avatar'],true);
			
		if (empty ( $avatar )){
			$avatar[30] = DEF_AVATAR;$avatar[45] = DEF_AVATAR;$avatar[90] = DEF_AVATAR;$avatar[180] = DEF_AVATAR;
		}
		
		$data ['avatar'] = $avatar;
		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		//获取积分相关信息
		$data ['creditinfo'] = $this->asklogic->get_credit_info ( $uid );
		
		//获取擅长分类信息--是否专家
		if ($data ['userinfo'] ['expert'] != 0) {
			$data ['categoryinfo'] = $this->asklogic->get_expert_category_list ( $data ['userinfo'] ['cids'] );
		}
		
		$data ['adopt'] = $this->asklogic->get_adopt_percentage ( $uid );
		
		//获取相关动态信息
		$data ['new_que_ans'] = $this->asklogic->get_related_que_ans ( $uid );
		
		//获取公告
		$limit = " order by time desc limit 5";
		
		$data ['new_article'] = $this->asklogic->get_article_list ( array (), "", $limit, "Y-m-d" );
		
		$data ['mod'] = '';
		
		$data ['who'] = "我";
		
		if ($uid == $this->userinfo ['uid']) {
			
			$condition = " and hidden = 0 ";
			
			$limit = " order by time desc limit 5";
			
			$data ['new_question'] = $this->asklogic->get_questions_list_tem ( array (), $condition, $limit, 'index', 'Y-m-d' );
			
			foreach ($data ['new_question'] as $key=>$value){
				$data ['new_question'][$key]['title']=cutstr($value['title'], 80, '');
			}
			
			$this->render ( 'userHome', $data );
		} else {
			
			$data ['who'] = "ta";
			
			$data ['trends'] = array ();
			
			$this->render ( 'userIndex', $data );
		}
	}
	
	/**
	 * 进入个人首页-回答页面
	 */
	function show_home_answer() {
		$condition = "";
		
		$uid = $this->check_params ( 'uid' );
		
		if (is_numeric ( $uid )) {
			
			$uid = ($uid == 0) ? $this->userinfo ['uid'] : $uid;
			
			$on_page = 1;
		} else {
			$src = explode ( "_", $uid );
			
			$uid = is_numeric ( $src [0] ) ? $src [0] : $this->userinfo ['uid'];
			
			$on_page = (isset ( $src [1] ) && is_numeric ( $src [1] )) && $src [1] > 0 ? $src [1] : 1;
		}
		
		$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		//---------------------------------
		if ($uid > 0)
			$condition .= " and authorid = " . $uid;
		
		$page_size = 10;
		
		$action = '/home_answer/' . $uid . '_';
		
		//获取分页相关数据
		$page = $this->asklogic->get_page ( t_answer, $condition, $on_page, $page_size, $action );
		
		$limit = " order by time desc limit " . $page ['lower'] . ", " . $page_size . " ";
		
		$page ['answers'] = $this->asklogic->get_answers_list_tem ( array (), $condition, $limit );
		//----------------------------------------
		

		//获取头像
		//$avatar = $this->asklogic->get_user_avatar_by_username ( $data ['userinfo'] ['username'] );
		
		$avatar=json_decode($data ['userinfo']['avatar'],true);
			
		if (empty ( $avatar )){
			$avatar[30] = DEF_AVATAR;$avatar[45] = DEF_AVATAR;$avatar[90] = DEF_AVATAR;$avatar[180] = DEF_AVATAR;
		}
		
		$data ['avatar'] = $avatar;
		
		//获取回答信息
		$data ['answer_list'] = $page;
		
		$data ['mod'] = 'answer';
		
		$data ['who'] = "ta";
		
		if ($uid == $this->userinfo ['uid'])
			$data ['who'] = "我";
		
		$this->render ( 'userHome-answer', $data );
	}
	
	/**
	 * 进入个人首页-问题页面
	 */
	function show_home_question() {
		
		$condition = "";
		
		$uid = $this->check_params ( 'uid' );
		
		if (is_numeric ( $uid )) {
			
			$uid = ($uid == 0) ? $this->userinfo ['uid'] : $uid;
			
			$on_page = 1;
		} else {
			$src = explode ( "_", $uid );
			
			$uid = is_numeric ( $src [0] ) ? $src [0] : $this->userinfo ['uid'];
			
			$on_page = (isset ( $src [1] ) && is_numeric ( $src [1] )) && $src [1] > 0 ? $src [1] : 1;
		}
		
		$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		//---------------------------------
		if ($uid > 0)
			$condition .= " and authorid = " . $uid;
		
		$page_size = 10;
		
		$action = '' . $uid . "_";
		
		$condition .= " and hidden=0 ";
		
		//获取分页相关数据
		$page = $this->asklogic->get_page ( t_question, $condition, $on_page, $page_size, $action );
		
		$limit = " order by time desc limit " . $page ['lower'] . ", " . $page_size . " ";
		
		$page ['questions'] = $this->asklogic->get_questions_list_tem ( array (), $condition, $limit, "home", "Y-m-d" );
		
		$page ['vip_questions'] = array ();
		
		if ($uid == $this->userinfo ['uid'])
			$page ['vip_questions'] = $this->asklogic->get_vip_questions_by_uid ( $uid );
		
		//----------------------------------------
		$data ['question_list'] = $page;
		
		//获取头像
		//$avatar = $this->asklogic->get_user_avatar_by_username ( $data ['userinfo'] ['username'] );
		
		$avatar=json_decode($data ['userinfo']['avatar'],true);
			
		if (empty ( $avatar )){
			$avatar[30] = DEF_AVATAR;$avatar[45] = DEF_AVATAR;$avatar[90] = DEF_AVATAR;$avatar[180] = DEF_AVATAR;
		}
		
		$data ['avatar'] = $avatar;
		
		$data ['mod'] = 'question';
		
		$data ['who'] = "ta";
		
		if ($uid == $this->userinfo ['uid'])
			$data ['who'] = "我";
		
		$this->render ( 'userHome-ask', $data );
	}
	
	/**
	 * 显示发起问题页面
	 * 页面代码
		<div class="enterBtn rewardPost clearfix">
					<a href="/question/add/credit" class="enterB">悬赏提问</a><p>在"普通提问"的情况下，提供"赏金"给回答者，能吸引高手为你解答。</p>
				</div>
	 *
	 * 
	 */
	public function show_ask_post() {
		
		//检测问题数
		require_once SITE_PATH . '/protected/config/auth_issue.conf.php';
		$auth = $auth ['GENERAL_USER_GROUP' . $this->userinfo ['groupid']];
		$issue = $this->asklogic->auth_question_issue ( $this->userinfo ['uid'], $this->userinfo ['groupid'], $auth );
		
		if ($issue == 2)
			$this->Messager ( "您今天提问条数(" . $auth ['DAY_TOTALS'] . ")已用完", "/" );
		elseif ($issue == 3)
			$this->Messager ( "每" . $auth ['TIME_INTERVAL']/60 . "分钟内只可以发布" . $auth ['TIME_TOTALS'] . "条", "/" );
		
		//暂停悬赏提问功能
		$credit = $this->check_params ( "is_credit" );
		$data ['is_credit'] =false; //empty ( $credit ) || $credit != "credit" ? false : true;
		
		//获取分类信息
		$data ['category'] = $this->asklogic->get_category_list ();
		//获取用户基本信息
		$data ['userinfo'] = array_merge ( $this->userlogic->get_users_information ( $this->userinfo ['uid'] ), $this->userinfo );
		
		//悬赏
		if ($data ['is_credit']) {
			$option = "";
			for($i = 5; $i <= $data ['userinfo'] ['credit3']; $i = $i + 5) {
				$option .= "<option value='" . $i . "'>" . $i . "</option>";
				if ($i >= 80)
					break;
			}
			$data ['option'] = $option;
		}
		
		$data ['mod'] = "askpost";
		$this->render ( 'askPost', $data );
	}
	
	/**
	 * 显示问答详情页
	 */
	public function show_ask_page() {
		
		$id = $this->check_params ( 'qid' );
		
		$id = (! is_numeric ( $id )) ? 0 : $id;
		
		//获取问题信息和用户信息
		$data ['question_info'] = $this->asklogic->get_question_user_info ( $id );
		
		if (! $data ['question_info'])
			$this->Messager ( "未找到您的问题", "/" );
		
		//获取该问题的回答和用户信息
		$data ['answer_info'] = $this->asklogic->get_answer_user_info ( $id );
		
		$is_answer = false;
		
		foreach ( $data ['answer_info'] as $key => $value ) {
			//登录用户是否已经回答
			if ((! isset ( $this->userinfo ['uid'] )) || $value ['uid'] == $this->userinfo ['uid'])
				$is_answer = true;
			
		//是否是最佳答案
			if ($value ['adopttime'] != 0)
				$data ['is_best_answer'] = $value;
		}
		
		$data ['is_answer'] = $is_answer;
		
		//游客用户
		$data ['login_uid'] = 0;
		
		$data ['groupid'] = 0;
		
		$data ['aids'] = array ();
		
		//获取登录用户信息
		if (! empty ( $this->userinfo ['uid'] )) {
			
			$data ['login_uid'] = $this->userinfo ['uid'];
			
			$data ['user_info'] = $this->userlogic->get_users_information ( $this->userinfo ['uid'] );
			
			if (! empty ( $data ['user_info'] )) {
				$data ['aids'] = explode ( ",", $data ['user_info'] ['aids'] );
				
				$data ['groupid'] = $data ['user_info'] ['groupid'];
			}
		}
		
		$data ['mod'] = 'askpage';
		
		//获取相关问题
		$data ['like_question'] = $this->asklogic->get_like_questions_list ( $id, $data ['question_info'] ['cid'] );
		
		//获取相关已解决问题
		$data ['resolved_question'] = $this->asklogic->get_like_questions_list ( $id, $data ['question_info'] ['cid'], QUESTOIN_STATUS_RESOLVED );
		
		//获取消费基金
		$data ['fund'] = $this->asklogic->get_fund ();
		
		$this->render ( 'askPage', $data );
	}
	
	/**
	 * 登录页面
	 */
	function login() {
		
		$data ['username'] = "";
		
		if (isset ( $_COOKIE ['auth'] )) {
			$data ['username'] = $_COOKIE ['auth'];
		}
		
		$this->render ( 'login', $data );
	}
	
	/**
	 * 获取用户系统信息或者推送信息--修改请求方式
	 */
	function show_home_message() {
		
		$uid = $this->userinfo ['uid'];
		
		$fromuid = $this->get_args ( 'fromuid' ) === false ? 1 : $this->get_args ( 'fromuid' );
		
		$time = $this->get_args ( 'time' ) ? $this->get_args ( 'time' ) : 7;
		
		$on_page = $this->get_args ( 'on_page' ) ? $this->get_args ( 'on_page' ) : 1;
		
		$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		//获取系统信息
		$data ['message_list'] = $this->asklogic->get_messages_list ( $uid, $fromuid, $time, $on_page );
		
		//获取头像
		$avatar = $this->asklogic->get_user_avatar_by_username ( $data ['userinfo'] ['username'] );
		
		$data ['avatar'] = $avatar;
		
		$data ['fromuid'] = $fromuid;
		
		$data ['time'] = $time;
		
		$data ['on_page'] = $on_page;
		
		$this->render ( 'userHome-msg', $data );
	}
	
	/**
	 * 进入用户首页-修改头像
	 */
	function show_home_avatar() {
		
		if (is_numeric ( $this->params ['uid'] ))
			
			$uid = ($this->params ['uid'] == 0) ? $this->userinfo ['uid'] : $this->params ['uid'];
		else {
			
			$uid = $this->userinfo ['uid'];
		}
		
		//获取登录用户基本信息 --获取用户登录信息--需要修改
		if ($uid == $this->userinfo ['uid'])
			$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		else
			$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		//获取擅长分类信息--是否专家
		if ($data ['userinfo'] ['expert'] != 0) {
			$data ['categoryinfo'] = "";
		}
		
		//获取头像
//		$avatar = $this->asklogic->get_user_avatar_by_username ( $data ['userinfo'] ['username'] );

		$avatar=json_decode($data ['userinfo']['avatar'],true);

		if (empty ( $avatar )){
			$avatar[30] = DEF_AVATAR;$avatar[45] = DEF_AVATAR;$avatar[90] = DEF_AVATAR;$avatar[180] = DEF_AVATAR;
		}
		
		$data ['avatar'] = $avatar;
		
		$data ['mod'] = 'info';
		
		$data ['who'] = "我";
		
		require_once (SITE_PATH . '/protected/plugin/client.php');
		
		$client = new client ( ZHSSO );
		
		$tuid = $_COOKIE ['tuid'];
		
		$data ['avatar_flash'] = $client->ps_getavatar_upload_html ( $tuid );
		
		$this->render ( 'userHome-avatar', $data );
	}
	
	/**
	 * 进入用户首页-我的资料
	 */
	function show_home_per_info() {
		
		if (is_numeric ( $this->params ['uid'] ))
			
			$uid = ($this->params ['uid'] == 0) ? $this->userinfo ['uid'] : $this->params ['uid'];
		else {
			$uid = $this->userinfo ['uid'];
		
		}
		
		//获取登录用户基本信息 --获取用户登录信息--需要修改
		$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );

		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		//获取擅长分类信息--是否专家
		if ($data ['userinfo'] ['expert'] != 0) {
			
			$data ['categoryinfo'] = $this->asklogic->get_category_list ();
		}
		//获取头像
		//$avatar = $this->asklogic->get_user_avatar_by_username ( $data ['userinfo'] ['username'] );
		
		$avatar=json_decode($data ['userinfo']['avatar'],true);
			
		if (empty ( $avatar )){
			$avatar[30] = DEF_AVATAR;$avatar[45] = DEF_AVATAR;$avatar[90] = DEF_AVATAR;$avatar[180] = DEF_AVATAR;
		}
		
		$data ['avatar'] = $avatar;
		
		//获取系统设置
		require_once (SITE_PATH . '/protected/config/send_email.conf.php');
		
		$data ['email'] = $email;
		
		$data['email_user_set']=$this->userlogic->get_email_config ( $uid );
		
		$data ['who'] = "我";
		
		$data['mod']="info";
		
		$this->render ( 'userHome-profile', $data );
	}
	
	/**
	 * 进入名师答疑
	 */
	function show_advisory() {
		$condition = "";
		
		$type = $this->check_params ( 'type' );
		
		$on_page = $this->check_params ( 'on_page' );
		
		$type = empty ( $type ) ? "new" : $type;
		
		$on_page = is_numeric ( $on_page ) && $on_page > 0 ? $on_page : 1;
		
		$page_size = 10;
		
		$action = '/advisory/' . $type . "/";
		
		if ($type == "hot")
			$condition = " and hot=1 ";
		
		if ($type == "answer")
			$condition = " and answers!=0 ";
		
		$condition .= " and status !=" . PAID_NO_FILL_IN;
		
		//获取分页相关数据
		$page = $this->asklogic->get_page ( t_vipquestion, $condition, $on_page, $page_size, $action );
		
		$limit = " order by time desc limit " . $page ['lower'] . ", " . $page_size . " ";
		
		$page ['vip_questions'] = $this->asklogic->get_vip_questions_list ( array (), $condition, $limit );
		
		$data ['type'] = $type;
		
		$data ['vipinfo'] = $page;
		
		$data ['userinfo'] = $this->userinfo;
		
		$data ['keywork_advisory'] = "";
		
		$data ['advisory'] = true;
		
		$this->render ( 'advisory_index', $data );
	}
	
	/**
	 * 名师答疑-检索
	 */
	function search_show_advisory() {
		
		require_once (XUNSEARCH_URL);
		
		$keywork = $this->get_args ( 'keywork_advisory' );
		
		$type = $this->get_args ( 'type' );
		
		$on_page = $this->get_args ( 'on_page' );
		
		$type = empty ( $type ) ? "new" : $type;
		
		$on_page = is_numeric ( $on_page ) && $on_page > 0 ? $on_page : 1;
		
		if (empty ( $keywork ))
			$this->Messager ( "请输入需要查找的内容", "/advisory" );
		
		//获取分页相关数据
		$search = $this->asklogic->search_advisory ( $keywork, $type, $on_page );
		
		$info = $search ['page'];
		
		$info ['vip_questions'] = $search ['vip_questions'];
		
		$data ['type'] = $type;
		
		$data ['vipinfo'] = $info;
		
		$data ['userinfo'] = $this->userinfo;
		
		$data ['keywork_advisory'] = $keywork;
		
		$data ['advisory'] = true;
		
		$this->render ( 'advisory_index', $data );
	}
	
	/**
	 * 进入名师答疑详情页
	 */
	function show_advisory_page() {
		
		$id = $this->check_params ( 'id' );
		
		$id = is_numeric ( $id ) && $id > 0 ? $id : 1;
		
		//获取名师答疑
		if ($this->userinfo ['groupid'] == USER_VIP || $this->userinfo ['groupid'] == SUPER_ADMIN_ID || $this->userinfo ['groupid'] == ADMIN_ID)
			$vip_question = $this->asklogic->get_vip_questions_by_id ( $id );
		else {
			$vip_question = $this->asklogic->get_vip_question_by_quid ( $id, $this->userinfo ['uid'] );
			
			if (empty ( $vip_question ))
				$this->Messager ( "没有权限浏览相关的名师答疑-请提升为年费会员", "/advisory" );
		}
		
		if (empty ( $vip_question ))
			$this->Messager ( "没有找到相关的名师答疑", "/advisory" );
		
		//获取问题用户
		$vip_question_user = $this->userlogic->get_users_information ( $vip_question ['authorid'] );
		
		$vip_question_user ['avatar'] = $this->asklogic->get_user_avatar_by_username ( $vip_question ['author'] );
		
		//获取回答
		$vip_answer = $this->asklogic->get_vip_answer_by_id ( $id );
		
		//获取讨论
		$data ['vip_discuss'] = $this->asklogic->get_discuss_by_qid ( $id );
		
		//获取相关问题
		$condition = "and id!=" . $id . " and status !=" . PAID_NO_FILL_IN;
		
		$limit = " order by time desc limit 5";
		
		$like_vip_question = $this->asklogic->get_vip_questions_list ( array (), $condition, $limit );
		
		$data ['like_vip_question'] = $like_vip_question;
		
		$data ['vip_answer'] = $vip_answer;
		
		$data ['vip_question'] = $vip_question;
		
		$data ['vip_question_user'] = $vip_question_user;
		
		$data ['keywork_advisory'] = "";
		
		$data ['login_user'] = $this->userinfo;
		
		$data ['advisory'] = true;
		
		$data ['mod'] = 'advisorypage';
		
		$this->render ( 'advisory_page', $data );
	}
	
	/**
	 * 进入我的订单详情页
	 */
	function show_my_pay_oder() {
		
		$on_page = $this->get_args ( 'on_page' );
		
		$time = $this->get_args ( 'time' );
		
		$on_page = is_numeric ( $on_page ) && $on_page > 0 ? $on_page : 1;
		
		$time = is_numeric ( $time ) && $time >= 0 ? $time : 7;
		
		$uid = $this->userinfo ['uid'];
		
		$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		//财富综合信息
		$data ['creditinfo'] = $this->asklogic->get_credit_info ( $uid );
		
		//财富明细信息
		$page_size = 15;
		
		$action = "/home_pay_poder?time=" . $time . "&on_page=";
		
		$str_time=" and time>UNIX_TIMESTAMP( SUBDATE( now( ) , INTERVAL " . $time . " DAY ))";
		
		if($time==0)
			$str_time="";
			
		$condition = "  and uid = " . $uid . $str_time;
		
		$page = $this->asklogic->get_page ( t_credit3log, $condition, $on_page, $page_size, $action );
		
		$limit = " order by time desc limit " . $page ['lower'] . ", " . $page_size . " ";
		
		$page ['credit3log'] = $this->asklogic->get_credit3_list ( array (), $condition, $limit );
		
		$data ['credit3log'] = $page;
		
		//获取头像
		//$avatar = $this->asklogic->get_user_avatar_by_username ( $data ['userinfo'] ['username'] );
		
		$avatar=json_decode($data ['userinfo']['avatar'],true);
			
		if (empty ( $avatar )){
			$avatar[30] = DEF_AVATAR;$avatar[45] = DEF_AVATAR;$avatar[90] = DEF_AVATAR;$avatar[180] = DEF_AVATAR;
		}
		
		$data ['avatar'] = $avatar;
		
		$data ['time'] = $time;
		
		$data ['on_page'] = $on_page;
		
		$data ['who'] = "我";
		
		$data ['mod'] = "myoder";
		
		$this->render ( 'userHome-payOder', $data );
	}
	
	/**
	 * 进入充值页面
	 */
	function show_my_recharge() {
		
		$uid = $this->check_params ( 'uid' );
		
		if (is_numeric ( $uid ))
			
			$uid = ($uid == 0) ? $this->userinfo ['uid'] : $uid;
		else {
			$uid = $this->userinfo ['uid'];
		
		}
		
		$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		$data ['who'] = "我";
		
		$this->render ( 'userHome_recharge', $data );
	}
	
	/**
	 * 显示公告
	 */
	function show_article_page() {
		$params ['id'] = $this->check_params ( 'id' );
		
		$data ['article'] = $this->userlogic->get_article_by_id ( $params ['id'] );
		
		$data ['like_article'] = $this->asklogic->get_article_other ( $params ['id'] );
		
		$this->render ( 'articlePage', $data );
	}
	
	/**
	 * 显示充值记录
	 */
	function show_recharge_oder() {
		
		$on_page = $this->get_args ( 'on_page' );
		
		$on_page = is_numeric ( $on_page ) && $on_page > 0 ? $on_page : 1;
		
		$uid = $this->userinfo ['uid'];
		
		//是否多余
		$data ['userinfo'] = $this->userlogic->get_users_information ( $uid );
		
		if (empty ( $data ['userinfo'] ))
			$this->Messager ( "请输入正确的访问地址", "/" );
		
		//获取充值记录
		$tmpArray=$this->asklogic->get_recharge($data['userinfo']['username']);	
        // 多送
        foreach ($tmpArray as $key => $value) {
            if (!empty($value['telephone']))
                $tmpArray[$key]['info'] = '(+'.$value['money']*0.05.')';
        }
		$data['v_mid'] = '22544863';            // 商户号，这里为测试商户号1001，替换为自己的商户号(老版商户号为4位或5位,新版为8位)即可
        $data['v_url'] = Doo::conf()->APP_URL . 'Receive'; // 请填写返回url,地址应为绝对路径,带有http协议
 		
        $data['key'] = 'smartcost@)!@onlinepaychinabank';            // 如果您还没有设置MD5密钥请登陆我们为您提供商户后台，地址：https://merchant3.chinabank.com.cn/
        $data['v_moneytype'] = "CNY";
		
		$data['PayOrderArray'] = $tmpArray;
		
		//财富明细信息
//		$page_size = 15;
//		
//		$action = "/home_recharge_oder?on_page=";
//		
//		$condition = "  and uid = " . $uid;
//		
//		$page = $this->asklogic->get_page ( t_bankjorunal, $condition, $on_page, $page_size, $action );
//		
//		$limit = " order by time desc limit " . $page ['lower'] . ", " . $page_size . " ";
//		
//		$page ['bank_jorunal'] = $this->asklogic->get_bank_jorunal_list ( array (), $condition, $limit );
//		
//		$data ['bank_jorunal'] = $page;
//		
//		$data ['on_page'] = $on_page;
//		<!-- if {{bank_jorunal.total_page}}!=0 -->
//			<div class="pageNav2 clearfix">
//	            <div class="pageList">
//	            <!-- if {{bank_jorunal.previous}}==0 -->
//				<span class="inactivePrev">上一页</span>
//				<!-- else -->
//				<a href="javascript:void(0)" id="get_oder_{{bank_jorunal.previous}}" data="{{bank_jorunal.previous}}" class="inactivePrev"  >上一页</a> 
//				<!-- endif -->	
//				{{bank_jorunal.page}}
//				<a href="javascript:void(0)" id="get_oder_{{bank_jorunal.previous}}" data="{{bank_jorunal.total_page}}"
//				class="paginate">... {{bank_jorunal.total_page}}</a> 
//				<!-- if {{bank_jorunal.next}}=={{bank_jorunal.on_page}} -->
//				<span class="inactivePrev">下一页</span>
//				<!-- else -->
//				<a href="javascript:void(0)" id="get_oder_{{bank_jorunal.next}}" data="{{bank_jorunal.next}}" class="next">下一页</a>
//				<!-- endif -->
//				</div>
//			</div>
//			<!-- endif -->
		
		
		
		
		//获取头像
		$avatar = $this->asklogic->get_user_avatar_by_username ( $data ['userinfo'] ['username'] );
		
		$data ['avatar'] = $avatar;
		
		$data ['who'] = "我";
		
		$data ['mod'] = "myoder";
		
		$this->render ( 'userHome-rechargeOder', $data );
	}
	
	function show_tip2(){
		
		$this->render ( 'tips2' );
	}
	
	/**
	 * 显示提示信息
	 */
	function show_messager() {
		$message = $this->get_args ( 'content' );
		
		$url = $this->get_args ( 'url' );
		
		$this->Messager ( $message, $url );
	}
	
	/**
	 * 获取get或者POST值
	 * @param string $name 属性名称
	 * @return fixed 值
	 */
	function get_args($name) {
		if (isset ( $_GET [$name] )) {
			if (is_array ( $_GET [$name] ))
				return $_GET [$name];
			else {
				return addslashes ( $_GET [$name] );
			
		//return  $_GET [$name] ;
			}
		
		} elseif (isset ( $_POST [$name] )) {
			if (is_array ( $_POST [$name] ))
				return $_POST [$name];
			else {
				return addslashes ( $_POST [$name] );
			
		//return $_POST [$name];
			}
		} else {
			
			return false;
		}
	}
	
	/**
	 * 检测数据输入的非法字符和转义非法字符
	 */
	function check_params($name = "") {
		if (isset ( $this->params [$name] )) {
			
			return addslashes ( $this->params [$name] );
		} else {
			
			return false;
		}
	}
	
	/**
	 * 限时跳转
	 * @param unknown_type $message
	 * @param unknown_type $redirectto
	 * @param unknown_type $time
	 * @param unknown_type $return_msg
	 * @param unknown_type $js
	 */
	function Messager($message, $redirectto = '', $time = -1, $return_msg = false, $js = null) {
		global $rewriteHandler;
		$data ['redirectto'] = $redirectto;
		$data ['message'] = $message;
		
		if ($time === - 1) {
			//配置文件
			//$time=(is_numeric($this->Config['msg_time'])?$this->Config['msg_time']:5);
			$data ['time'] = 2;
		}
		
		$data ['to_title'] = ($data ['redirectto'] === '' or $data ['redirectto'] == - 1) ? "返回上一页" : "跳转到指定页面";
		
		if ($data ['redirectto'] === null) {
			$return_msg = $return_msg === false ? "&nbsp;" : $return_msg;
		} else {
			$data ['redirectto'] = ($data ['redirectto'] !== '') ? $data ['redirectto'] : ($from_referer = referer ());
			//			if(str_exists($data['redirectto'],'mod=login','code=register','/login','/register'))
			//			{
			//				$referer='&referer='.urlencode('index.php?'.$_SERVER['QUERY_STRING']);
			//				$this->CookieHandler->Setvar('referer','index.php?'.$_SERVER['QUERY_STRING']);
			//			}
			

			if (is_numeric ( $data ['redirectto'] ) !== false and $data ['redirectto'] !== 0) {
				if ($data ['time'] !== null) {
					$data ['url_redirect'] = "<script language=\"JavaScript\" type=\"text/javascript\">\r\n";
					$data ['url_redirect'] .= sprintf ( "window.setTimeout(\"history.go(%s)\",%s);\r\n", $data ['redirectto'], $data ['time'] * 1000 );
					$data ['url_redirect'] .= "</script>\r\n";
				
				}
				
				$data ['redirectto'] = "javascript:history.go({$data['redirectto']})";
			} else {
				if ($rewriteHandler && null !== $data ['message']) {
					$data ['redirectto'] .= $referer;
					if (! $from_referer && ! $referer) {
						$data ['redirectto'] = $rewriteHandler->formatURL ( $data ['redirectto'], true );
					}
				}
				
				if ($data ['message'] === null) {
					$data ['redirectto'] = rawurldecode ( stripslashes ( ($data ['redirectto']) ) );
					@header ( "Location: " . $data ['redirectto'] ); #HEADER跳转
				}
				if ($data ['time'] !== null) {
					$data ['url_redirect'] = ($data ['redirectto'] ? '<meta http-equiv="refresh" content="' . $data ['time'] . '; URL=' . $data ['redirectto'] . '">' : null);
				}
			}
		}
		$title = "消息提示:" . (is_array ( $data ['message'] ) ? implode ( ',', $data ['message'] ) : $data ['message']);
		
		$title = strip_tags ( $title );
		if ($js != "") {
			$js = "<script language=\"JavaScript\" type=\"text/javascript\">{$js}</script>";
		}
		$additional_str = $data ['url_redirect'] . $js;
		
		$this->render ( 'messager', $data );
		
		exit ();
	}
	
	public function showcode(){
		session_start();
		header("Content-type: image/PNG");
		$w = 150;
		$h = 50;
		$fontface = "/opt/www/wenda/global/font/msyhbd.ttf"; //字体文件
		$str = "们以我到他会作时要动国产的一是工就年阶义发成部民可出能方进在了不和有大这主中人上为来分生对于学下级地个用同行面说种过命度革而多子后自社加小机也经力线本电高量长党得实家定深法表着水理化争现所二起政三好十战无农使性前等反体合斗路图把结第里正新开论之物从当两些还天资事队批点育重其思与间内去因件日利相由压员气业代全组数果期导平各基或月毛然如应形想制心样干都向变关问比展那它最及外没看治提五解系林者米群头意只明四道马认次文通但条较克又公孔领军流入接席位情运器并飞原油放立题质指建区验活众很教决特此常石强极土少已根共直团统式转别造切九你取西持总料连任志观调七么山程百报更见必真保热委手改管处己将修支识病象几先老光专什六型具示复安带每东增则完风回南广劳轮科北打积车计给节做务被整联步类集号列温装即毫知轴研单色坚据速防史拉世设达尔场织历花受求传口断况采精金界品判参层止边清至万确究书术状厂须离再目海交权且儿青才证低越际八试规斯近注办布门铁需走议县兵固除般引齿千胜细影济白格效置推空配刀叶率述今选养德话查差半敌始片施响收华觉备名红续均药标记难存测士身紧液派准斤角降维板许破述技消底床田势端感往神便贺村构照容非搞亚磨族火段算适讲按值美态黄易彪服早班麦削信排台声该击素张密害侯草何树肥继右属市严径螺检左页抗苏显苦英快称坏移约巴材省黑武培著河帝仅针怎植京助升王眼她抓含苗副杂普谈围食射源例致酸旧却充足短划剂宣环落首尺波承粉践府鱼随考刻靠够满夫失包住促枝局菌杆周护岩师举曲春元超负砂封换太模贫减阳扬江析亩木言球朝医校古呢稻宋听唯输滑站另卫字鼓刚写刘微略范供阿块某功套友限项余倒卷创律雨让骨远帮初皮播优占死毒圈伟季训控激找叫云互跟裂粮粒母练塞钢顶策双留误础吸阻故寸盾晚丝女散焊功株亲院冷彻弹错散商视艺灭版烈零室轻血倍缺厘泵察绝富城冲喷壤简否柱李望盘磁雄似困巩益洲脱投送奴侧润盖挥距星松送获兴独官混纪依未突架宽冬章湿偏纹吃执阀矿寨责熟稳夺硬价努翻奇甲预职评读背协损棉侵灰虽矛厚罗泥辟告卵箱掌氧恩爱停曾溶营终纲孟钱待尽俄缩沙退陈讨奋械载胞幼哪剥迫旋征槽倒握担仍呀鲜吧卡粗介钻逐弱脚怕盐末阴丰雾冠丙街莱贝辐肠付吉渗瑞惊顿挤秒悬姆烂森糖圣凹陶词迟蚕亿矩康遵牧遭幅园腔订香肉弟屋敏恢忘编印蜂急拿扩伤飞露核缘游振操央伍域甚迅辉异序免纸夜乡久隶缸夹念兰映沟乙吗儒杀汽磷艰晶插埃燃欢铁补咱芽永瓦倾阵碳演威附牙芽永瓦斜灌欧献顺猪洋腐请透司危括脉宜笑若尾束壮暴企菜穗楚汉愈绿拖牛份染既秋遍锻玉夏疗尖殖井费州访吹荣铜沿替滚客召旱悟刺脑措贯藏敢令隙炉壳硫煤迎铸粘探临薄旬善福纵择礼愿伏残雷延烟句纯渐耕跑泽慢栽鲁赤繁境潮横掉锥希池败船假亮谓托伙哲怀割摆贡呈劲财仪沉炼麻罪祖息车穿货销齐鼠抽画饲龙库守筑房歌寒喜哥洗蚀废纳腹乎录镜妇恶脂庄擦险赞钟摇典柄辩竹谷卖乱虚桥奥伯赶垂途额壁网截野遗静谋弄挂课镇妄盛耐援扎虑键归符庆聚绕摩忙舞遇索顾胶羊湖钉仁音迹碎伸灯避泛亡答勇频皇柳哈揭甘诺概宪浓岛袭谁洪谢炮浇斑讯懂灵蛋闭孩释乳巨徒私银伊景坦累匀霉杜乐勒隔弯绩招绍胡呼痛峰零柴簧午跳居尚丁秦稍追梁折耗碱殊岗挖氏刃剧堆赫荷胸衡勤膜篇登驻案刊秧缓凸役剪川雪链渔啦脸户洛孢勃盟买杨宗焦赛旗滤硅炭股坐蒸凝竟陷枪黎救冒暗洞犯筒您宋弧爆谬涂味津臂障褐陆啊健尊豆拔莫抵桑坡缝警挑污冰柬嘴啥饭塑寄赵喊垫丹渡耳刨虎笔稀昆浪萨茶滴浅拥穴覆伦娘吨浸袖珠雌妈紫戏塔锤震岁貌洁剖牢锋疑霸闪埔猛诉刷狠忽灾闹乔唐漏闻沈熔氯荒茎男凡抢像浆旁玻亦忠唱蒙予纷捕锁尤乘乌智淡允叛畜俘摸锈扫毕璃宝芯爷鉴秘净蒋钙肩腾枯抛轨堂拌爸循诱祝励肯酒绳穷塘燥泡袋朗喂铝软渠颗惯贸粪综墙趋彼届墨碍启逆卸航衣孙龄岭骗休借";
		$str = iconv('utf-8', 'gbk', $str);
		$code = "";
		for ($i = 0; $i < 4; $i++) {
		    $Xi = mt_rand(0, strlen($str) / 2);
		    if ($Xi % 2)
			$Xi+=1;
		    $code.=substr($str, $Xi, 2);
		}
		$_SESSION['vc'] = iconv("gbk", "UTF-8", $code);
		$im = imagecreatetruecolor($w, $h);
		$bkcolor = imagecolorallocate($im, 250, 250, 250);
		imagefill($im, 0, 0, $bkcolor);
		/* * *添加干扰** */
		for ($i = 0; $i < 15; $i++) {
		    $fontcolor = imagecolorallocate($im, mt_rand(0, 255), mt_rand(0, 255), mt_rand(0, 255));
		    imagearc($im, mt_rand(-10, $w), mt_rand(-10, $h), mt_rand(30, 300), mt_rand(20, 200), 55, 44, $fontcolor);
		}
		for ($i = 0; $i < 255; $i++) {
		    $fontcolor = imagecolorallocate($im, mt_rand(0, 255), mt_rand(0, 255), mt_rand(0, 255));
		    imagesetpixel($im, mt_rand(0, $w), mt_rand(0, $h), $fontcolor);
		}
		/* * *********内容******** */
		for ($i = 0; $i < 4; $i++) {
		    $fontcolor = imagecolorallocate($im, mt_rand(0, 120), mt_rand(0, 120), mt_rand(0, 120)); //这样保证随机出来的颜色较深。
		    $codex = iconv("GB2312", "UTF-8", substr($code, $i * 2, 2));
		    imagettftext($im, mt_rand(14, 18), mt_rand(-60, 60), 30 * $i + 20, mt_rand(30, 35), $fontcolor, $fontface, $codex);
		}
		imagepng($im);
		imagedestroy($im);
	}
}
?>
